<script>
  // Import modules
  import { max } from "d3-array";
  import {  scaleLinear, scaleOrdinal  } from "d3-scale";

  // Export variables
  export let data;
  export let scaling;
  export let city;

  // Size and margins
  const width = 945;
  const height = 450;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Define lists of values for variables
  const cities = ["Baltimore", "Chicago", "Los Angeles"];
  const building_type = ["FullServiceRestaurant", "Hospital", "LargeHotel", "LargeOffice", "MediumOffice", "MidriseApartment", "OutPatient", 
                        "PrimarySchool", "QuickServiceRestaurant", "SecondarySchool", "SmallHotel", "SmallOffice", "Stand-aloneRetail",
                        "StripMall", "SuperMarket", "Warehouse"];
  const days = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

// Filter the data by building type
function data_filter(data, bt){
  return data.filter(d => d.buildingtype == bt);
}

// Create function for finding the path points
function path_fcn(data, building_index, bt, scaling){
  let max_energy_consumption;

  if(scaling == "across"){
    max_energy_consumption = max(data, function(d) { return d.total_heating_energy;});
  } else {
    max_energy_consumption = max(data_filter(data, bt), function(d) { return d.total_heating_energy;});
  }

  // Filter the data
  data = data_filter(data, bt);

  // Define the scales
  const xScale = scaleLinear().domain([0, data.length]).range([10, innerWidth-145]);
  const yScale = scaleLinear().domain([0, max_energy_consumption]).range([innerHeight-(building_index)*10-55, innerHeight-(building_index+1)*10-55]);

  // Compute the paths coordinates
  let path_points = "M " + xScale(0) + " " + yScale(0) + " C ";
  for(let idx = 0; idx < data.length; idx++){
    path_points += xScale(idx) + " " + yScale(data[idx].total_heating_energy) + " ";
  }
  for(let idx=data.length-1; idx >= 0; idx--){
    path_points += xScale(idx) + " " + (yScale(-data[idx].total_heating_energy)) + " ";
  }

  // Return the path coordinates
  return path_points;
}

// Define color scale for the three cities
const fillScale = scaleOrdinal(["blue","darkgreen","darkred"]).domain(cities);
</script>


<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    {#each building_type as bt, index}
      <path d={path_fcn(data, 2.5*index, bt, scaling)} 
            fill="{fillScale(city)}"
            stroke="none"></path>
      <text class="building_name" x={790} y={(index*25)+5}>{bt}</text>
    {/each}
    <line x1="10" y1="395" x2={innerWidth-145} y2="395" />
    <text x={8} y={420}>December 1</text>
    <text x={innerWidth-236} y={420}>December 31</text>
    {#each days as day}
      <line x1={(innerWidth-155)/31*day-margin.left-5} y1="390" x2={(innerWidth-155)/31*day-margin.left-5} y2="400" />
    {/each}
    </g>
</svg>


<style>
  svg {
    border-radius: 5px;
  }

  .building_name{
    font-size: 13px;
  }

  line {
    stroke-width: 2;
    stroke: black;
  }
</style>


  
